/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util.chinese;

import com.jiuqi.util.chinese.ChineseDigit;
import com.jiuqi.util.chinese.ChineseDigitUnit;
import com.jiuqi.util.chinese.NoValidCharException;
import com.jiuqi.util.chinese.NotValidChineseDigitException;
import com.jiuqi.util.chinese.NotValidChineseDigitUnitException;
import com.jiuqi.util.chinese.NotValidChineseNumberException;
import com.jiuqi.util.chinese.StringSplitor;
import java.io.Serializable;
import java.util.ArrayList;

public class ChineseInt
implements Cloneable,
Serializable {
    private static final char[] INVALID_CHARS = new char[]{' ', '\u3000'};
    private String intValue;

    public ChineseInt() {
        this.intValue = "0";
    }

    public ChineseInt(long value) {
        this.intValue = String.valueOf(value);
    }

    public ChineseInt(String value) {
        if (ChineseInt.isIntString(value)) {
            this.intValue = value;
        } else {
            try {
                this.intValue = ChineseInt.valueOf(value);
            }
            catch (Exception exception) {
                this.intValue = "0";
            }
        }
    }

    public long longValue() {
        return Long.parseLong(this.intValue);
    }

    public String chineseValue(boolean showUnit, boolean useBigChar) {
        return ChineseInt.parseToChinese(this.intValue, showUnit, useBigChar);
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    public static String valueOf(String value) throws NotValidChineseNumberException, NoValidCharException {
        boolean negtive = false;
        StringSplitor chars = new StringSplitor(value, INVALID_CHARS);
        char thisChar = chars.getNextValidChar();
        if (thisChar == '(' || thisChar == '\uff08') {
            thisChar = chars.getNextValidChar();
            if (thisChar != '\u8d1f') throw new NotValidChineseNumberException("字符'('后面的字符无效，必须是'负'！");
            thisChar = chars.getNextValidChar();
            if (thisChar != ')' && thisChar != '\uff09') throw new NotValidChineseNumberException("字符'负'后面的字符无效，必须是')'！");
            negtive = true;
        }
        if (!negtive) {
            chars.rollBack();
        }
        boolean hasUnit = false;
        thisChar = chars.getNextValidChar();
        if (!ChineseDigit.isValidChineseDigit(thisChar)) throw new NotValidChineseNumberException("开头的字符\"" + thisChar + "\"不是数字！");
        thisChar = chars.getNextValidChar();
        if (ChineseDigitUnit.isValidChineseDigitUnit(String.valueOf(thisChar))) {
            hasUnit = true;
        }
        chars.rollBack();
        chars.rollBack();
        long longValue = 0L;
        if (hasUnit) {
            int tempValue = 0;
            while (chars.hasValidChar()) {
                thisChar = chars.getNextValidChar();
                if (ChineseDigit.isValidChineseDigit(thisChar)) {
                    try {
                        tempValue = ChineseDigit.valueOf(thisChar);
                    }
                    catch (NotValidChineseDigitException notValidChineseDigitException) {
                        throw new NotValidChineseNumberException("存在非法字符\"" + thisChar + "\"！");
                    }
                    if (chars.hasValidChar()) continue;
                    longValue += (long)tempValue;
                    continue;
                }
                if (!ChineseDigitUnit.isValidChineseDigitUnit(String.valueOf(thisChar))) throw new NotValidChineseNumberException("存在非法的字符\"" + thisChar + "\"！");
                if (ChineseDigitUnit.isLargeUnit(thisChar)) {
                    longValue += (long)tempValue;
                    tempValue = 0;
                    try {
                        longValue *= Long.parseLong(ChineseDigitUnit.valueOf(String.valueOf(thisChar)));
                        continue;
                    }
                    catch (NotValidChineseDigitUnitException notValidChineseDigitUnitException) {
                        throw new NotValidChineseNumberException("存在非法字符\"" + thisChar + "\"！");
                    }
                }
                try {
                    longValue += (long)tempValue * Long.parseLong(ChineseDigitUnit.valueOf(String.valueOf(thisChar)));
                }
                catch (NotValidChineseDigitUnitException notValidChineseDigitUnitException) {
                    throw new NotValidChineseNumberException("存在非法字符\"" + thisChar + "\"！");
                }
                tempValue = 0;
            }
        } else {
            StringBuffer stringValue = new StringBuffer();
            while (chars.hasValidChar()) {
                thisChar = chars.getNextValidChar();
                if (!ChineseDigit.isValidChineseDigit(thisChar)) continue;
                try {
                    stringValue.append(ChineseDigit.valueOf(thisChar));
                }
                catch (NotValidChineseDigitException notValidChineseDigitException) {
                    throw new NotValidChineseNumberException("存在非法字符\"" + thisChar + "\"！");
                }
            }
            longValue = Long.parseLong(stringValue.toString());
        }
        if (!negtive) return String.valueOf(longValue);
        longValue = -longValue;
        return String.valueOf(longValue);
    }

    public static String parseToChinese(String value, boolean showUnit, boolean useBigChar) {
        if (value != null && !value.equals("") && ChineseInt.isIntString(value)) {
            boolean negative = false;
            if (value.startsWith("-")) {
                negative = true;
                value = value.substring(1);
            }
            ArrayList<Integer> digits = new ArrayList<Integer>();
            int i = 0;
            while (i < value.length()) {
                int digit = value.charAt(i) - 48;
                if (digit >= 0 && digit <= 9) {
                    digits.add(new Integer(digit));
                }
                ++i;
            }
            StringBuffer result = new StringBuffer();
            if (!showUnit) {
                int i2 = 0;
                while (i2 < digits.size()) {
                    int digit = (Integer)digits.get(i2);
                    result.append(ChineseDigit.toChineseChar(digit, useBigChar));
                    ++i2;
                }
            } else {
                int cursor = digits.size();
                int smallInt = 0;
                int i3 = 0;
                while (cursor >= 0) {
                    smallInt = ChineseInt.getSmallInt(digits, i3);
                    if (smallInt != 0) {
                        result.insert(0, String.valueOf(ChineseInt.smallIntToChineseString(smallInt, useBigChar)) + ChineseDigitUnit.toChineseUnit(ChineseInt.getUnit(i3 * 4), useBigChar));
                    }
                    if (smallInt < 1000 && smallInt > 0 && (cursor -= 4) >= 0) {
                        result.insert(0, ChineseDigit.toChineseChar(0, useBigChar));
                    }
                    ++i3;
                }
            }
            if (negative) {
                result.insert(0, "(负)");
            }
            return result.toString();
        }
        throw new IllegalArgumentException("字符串\"" + value + "\"不是合法的阿拉伯数字字符串！");
    }

    private static int getSmallInt(ArrayList digits, int i) {
        int value = 0;
        int j = 0;
        int cursor = digits.size() - i * 4 - 1;
        while (j < 4 && cursor >= 0) {
            int digit = (Integer)digits.get(cursor);
            value = (int)((double)value + (double)digit * Math.pow(10.0, j));
            --cursor;
            ++j;
        }
        return value;
    }

    private static String smallIntToChineseString(int value, boolean useBigChar) {
        if (value >= 0 && value < 10000) {
            int[] digits = new int[4];
            int count = 3;
            while (value != 0) {
                digits[count] = value % 10;
                value /= 10;
                --count;
            }
            StringBuffer result = new StringBuffer();
            boolean allZeroBefore = true;
            boolean zeroExist = false;
            int i = 0;
            while (i < digits.length) {
                if (digits[i] != 0) {
                    result.append(String.valueOf(ChineseDigit.toChineseChar(digits[i], useBigChar)) + ChineseDigitUnit.toChineseUnit(ChineseInt.getUnit(3 - i), useBigChar));
                    allZeroBefore = false;
                    zeroExist = false;
                } else if (!allZeroBefore) {
                    boolean allZeroAfter = true;
                    int j = i + 1;
                    while (j < 4) {
                        if (digits[j] != 0) {
                            allZeroAfter = false;
                            break;
                        }
                        ++j;
                    }
                    if (!allZeroAfter && !zeroExist) {
                        result.append(ChineseDigit.toChineseChar(0, useBigChar));
                        zeroExist = true;
                    }
                }
                ++i;
            }
            return result.toString();
        }
        throw new IllegalArgumentException("只能解析0-9999的整数");
    }

    static boolean isIntString(String value) {
        if (value.startsWith("-")) {
            value = value.substring(1);
        }
        return ChineseDigitUnit.isDigitString(value);
    }

    private static String getUnit(int i) {
        StringBuffer sb = new StringBuffer("1");
        int j = 0;
        while (j < i) {
            sb.append("0");
            ++j;
        }
        return sb.toString();
    }

    public Object clone() {
        return new ChineseInt(this.intValue);
    }

    public boolean equals(Object o) {
        if (o == this) {
            return true;
        }
        if (!(o instanceof ChineseInt)) {
            return false;
        }
        ChineseInt value = (ChineseInt)o;
        return this.intValue.equals(value.intValue);
    }

    public int hashCode() {
        int result = super.hashCode();
        if (this.intValue != null) {
            result ^= this.intValue.hashCode();
        }
        return result;
    }

    public String toString() {
        return this.chineseValue(true, false);
    }
}

